#include "StdAfx.h"
#include "ActionHistory.h"

CActionHistory::CActionHistory(void)
{
	m_currentPos = -1;
}

CActionHistory::~CActionHistory(void)
{
	//TODO delete all the memory
	int depth = (int) stack.size();
	for (int i = 0; i< depth; i++) {
		delete stack.back();
		stack.pop_back();
	}
	stack.clear();
}

void CActionHistory::Add(CImage *p_Image)
{
	while (m_currentPos < ((int) stack.size()-1)) {
		delete stack.back();
		stack.pop_back();
	}
	
	stack.push_back(new CImage());
	stack.back()->Create(p_Image->GetWidth(), p_Image->GetHeight(), p_Image->GetBPP());
	p_Image->BitBlt(stack.back()->GetDC(), 0, 0, SRCCOPY);
	stack.back()->ReleaseDC();

	if (stack.size() > MAX_HISTORY) {
		delete stack[1];
		stack.erase(stack.begin() + 1);
	} else 
		m_currentPos++;

}

CImage * CActionHistory::Get(bool undo)
{
	if (undo) {
		if (m_currentPos > 0) m_currentPos--;
		return stack[m_currentPos];
	} else {
		if (m_currentPos < ((int) stack.size())-1) {
			m_currentPos++;
			return stack[m_currentPos];
		} else return stack.back();
	}
}
