// AddNoiseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graff.h"
#include "AddNoiseDlg.h"


// CAddNoiseDlg dialog

IMPLEMENT_DYNAMIC(CAddNoiseDlg, CDialog)

CAddNoiseDlg::CAddNoiseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddNoiseDlg::IDD, pParent)
	, NoiseAmount(0)
	
	, m_monochromatic(false)
	, m_uniform(false)
{
	_propertyChangedRoutine = NULL;
	tis = new AN_DLG_THREADINFOSTRUCT;
	tis->hWnd = m_hWnd;
	tis->pCGraffView = NULL;
	tis->NoiseAmount = 0;
	tis->isUniform = true;
	tis->isMonochromatic = false;

	pThread = NULL;
}

CAddNoiseDlg::~CAddNoiseDlg()
{
}

void CAddNoiseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_AddNoiseAmount);
	DDX_Control(pDX, IDC_EDIT1, m_AddNoiseString);
	DDX_Control(pDX, IDC_RADIO1, m_RadioDistribution);
	DDX_Control(pDX, IDC_CHECK1, m_Monochromatic);
	DDX_Control(pDX, IDC_CHECK2, m_PreviewEdit);
}


BEGIN_MESSAGE_MAP(CAddNoiseDlg, CDialog)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, &CAddNoiseDlg::OnNMCustomdrawSlider1)
	ON_BN_CLICKED(IDOK, &CAddNoiseDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_CHECK2, &CAddNoiseDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_CHECK1, &CAddNoiseDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_RADIO1, &CAddNoiseDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CAddNoiseDlg::OnBnClickedRadio2)
END_MESSAGE_MAP()


// CAddNoiseDlg message handlers

BOOL CAddNoiseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	m_AddNoiseAmount.SetRange(0, 40000);
	NoiseAmount = 0;
	m_NoiseAmount = 0;
	m_PreviewEdit.SetCheck(BST_CHECKED);
	m_RadioDistribution.SetCheck(BST_CHECKED);

	CString str;
	str.Format("0.00");
	m_AddNoiseString.SetSel(0, -1);
	m_AddNoiseString.ReplaceSel(str);
	m_AddNoiseString.UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CAddNoiseDlg::OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	
	//IF =================================
	float CurrentNoiseAmount = (float) m_AddNoiseAmount.GetPos();
	CurrentNoiseAmount /= 100;
	CurrentNoiseAmount = CurrentNoiseAmount * CurrentNoiseAmount / 400;

	if (CurrentNoiseAmount != NoiseAmount) {
		CString str;
		NoiseAmount = (float) m_AddNoiseAmount.GetPos();
		NoiseAmount /= 100;
		NoiseAmount = NoiseAmount * NoiseAmount / 400;
		str.Format("%3.2f", NoiseAmount);
		m_AddNoiseString.SetSel(0, -1);
		m_AddNoiseString.ReplaceSel(str);
		m_AddNoiseString.UpdateData();

		if ((m_PreviewEdit.GetCheck() == BST_CHECKED) && (_propertyChangedRoutine != NULL) && (tis->pCGraffView != NULL)) {
			tis->NoiseAmount = NoiseAmount;
			if (m_RadioDistribution.GetCheck() == BST_CHECKED) tis->isUniform = true; else tis->isUniform = false;
			if (m_Monochromatic.GetCheck() == BST_CHECKED) tis->isMonochromatic = true; else tis->isMonochromatic = false;
			pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
		}
	}
	*pResult = 0;
}

void CAddNoiseDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	m_NoiseAmount = NoiseAmount;
	if (m_RadioDistribution.GetCheck() == BST_CHECKED) m_uniform = TRUE; else m_uniform = FALSE;
	if (m_Monochromatic.GetCheck() == BST_CHECKED) m_monochromatic = TRUE; else m_monochromatic = FALSE;
	OnOK();
}

void CAddNoiseDlg::OnBnClickedCheck2()
{
	// TODO: Add your control notification handler code here
	if (m_PreviewEdit.GetCheck() == BST_CHECKED)
	{
		tis->NoiseAmount = NoiseAmount;
		if (m_RadioDistribution.GetCheck() == BST_CHECKED) tis->isUniform = true; else tis->isUniform = false;
		if (m_Monochromatic.GetCheck() == BST_CHECKED) tis->isMonochromatic = true; else tis->isMonochromatic = false;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	} else 
	{
		tis->NoiseAmount = 0;
		tis->isUniform = true;
		tis->isMonochromatic = false;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	}
}

void CAddNoiseDlg::SetPropertyChangeHandler(AFX_THREADPROC handler, void * cview)
{
	_propertyChangedRoutine = handler;
	tis->pCGraffView = cview;
}

void CAddNoiseDlg::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
	if (m_PreviewEdit.GetCheck() == BST_CHECKED)
	{
		tis->NoiseAmount = NoiseAmount;
		if (m_RadioDistribution.GetCheck() == BST_CHECKED) tis->isUniform = true; else tis->isUniform = false;
		if (m_Monochromatic.GetCheck() == BST_CHECKED) tis->isMonochromatic = true; else tis->isMonochromatic = false;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	} 
}

void CAddNoiseDlg::OnBnClickedRadio1()
{
	// TODO: Add your control notification handler code here
	if (m_PreviewEdit.GetCheck() == BST_CHECKED)
	{
		tis->NoiseAmount = NoiseAmount;
		if (m_RadioDistribution.GetCheck() == BST_CHECKED) tis->isUniform = true; else tis->isUniform = false;
		if (m_Monochromatic.GetCheck() == BST_CHECKED) tis->isMonochromatic = true; else tis->isMonochromatic = false;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	} 
}

void CAddNoiseDlg::OnBnClickedRadio2()
{
	// TODO: Add your control notification handler code here
	if (m_PreviewEdit.GetCheck() == BST_CHECKED)
	{
		tis->NoiseAmount = NoiseAmount;
		if (m_RadioDistribution.GetCheck() == BST_CHECKED) tis->isUniform = true; else tis->isUniform = false;
		if (m_Monochromatic.GetCheck() == BST_CHECKED) tis->isMonochromatic = true; else tis->isMonochromatic = false;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	} 
}
