// BCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graff.h"
#include "BCDlg.h"


// CBCDlg dialog

IMPLEMENT_DYNAMIC(CBCDlg, CDialog)

CBCDlg::CBCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBCDlg::IDD, pParent)
	, m_BrightnessAmount(0)
	, m_ContrastAmount(0)
{
	_propertyChangedRoutine = NULL;
	tis = new BC_DLG_THREADINFOSTRUCT;
	tis->hWnd = m_hWnd;
	tis->pCGraffView = NULL;
	tis->Contrast = 1;
	tis->Brightness = 0;

	pThread = NULL;
}

CBCDlg::~CBCDlg()
{
}

void CBCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_BrightnessSlider);
	DDX_Control(pDX, IDC_EDIT1, m_BrightnessEdit);
	DDX_Control(pDX, IDC_SLIDER2, m_ContrastSlider);
	DDX_Control(pDX, IDC_EDIT2, m_ContrastEdit);
	DDX_Control(pDX, IDC_PREVIEW_CHECK, m_PreviewEdit);
}


BEGIN_MESSAGE_MAP(CBCDlg, CDialog)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER1, &CBCDlg::OnNMCustomdrawSlider1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER2, &CBCDlg::OnNMCustomdrawSlider2)
	ON_BN_CLICKED(IDOK, &CBCDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_PREVIEW_CHECK, &CBCDlg::OnBnClickedPreviewCheck)
END_MESSAGE_MAP()


// CBCDlg message handlers

BOOL CBCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	m_BrightnessSlider.SetRange(0, 200);
	m_BrightnessSlider.SetPos(100);
	m_BrightnessAmount = 0;

	m_ContrastSlider.SetRange(0, 200);
	m_ContrastSlider.SetPos(100);
	m_ContrastAmount = 0;

	m_PreviewEdit.SetCheck(BST_CHECKED);

	m_BrightnessEdit.SetSel(0, -1);
	m_BrightnessEdit.ReplaceSel("0");
	m_BrightnessEdit.UpdateData();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CBCDlg::OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	
	if (m_BrightnessAmount != (float) (m_BrightnessSlider.GetPos() - 100)) {

		CString str;
		if (m_BrightnessSlider.GetPos() > 100) str.Format("+%d", m_BrightnessSlider.GetPos() - 100);
		else str.Format("%d", m_BrightnessSlider.GetPos() - 100);
		m_BrightnessEdit.SetSel(0, -1);
		m_BrightnessEdit.ReplaceSel(str);
		m_BrightnessEdit.UpdateData();

		m_BrightnessAmount = (float) (m_BrightnessSlider.GetPos() - 100);

		if ((m_PreviewEdit.GetCheck() == BST_CHECKED) && (_propertyChangedRoutine != NULL) && (tis->pCGraffView != NULL)) {
			tis->Brightness = m_BrightnessAmount;	
			pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
		}
		
	}
	
	*pResult = 0;
}

void CBCDlg::OnNMCustomdrawSlider2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here

	float CurrentContrastAmount = ((float) (m_ContrastSlider.GetPos())) / 100;
	if (CurrentContrastAmount > 1) CurrentContrastAmount *= CurrentContrastAmount;

	if (CurrentContrastAmount != m_ContrastAmount) {
		CString str;
		if (m_ContrastSlider.GetPos() > 100) str.Format("+%d", m_ContrastSlider.GetPos() - 100);
		else str.Format("%d", m_ContrastSlider.GetPos() - 100);
		m_ContrastEdit.SetSel(0, -1);
		m_ContrastEdit.ReplaceSel(str);
		m_ContrastEdit.UpdateData();

		m_ContrastAmount = ((float) (m_ContrastSlider.GetPos())) / 100;
		if (m_ContrastAmount > 1) m_ContrastAmount *= m_ContrastAmount;

		if ((m_PreviewEdit.GetCheck() == BST_CHECKED) && (_propertyChangedRoutine != NULL) && (tis->pCGraffView != NULL)) {
			tis->Contrast = m_ContrastAmount;	
			pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
		}
	}

	*pResult = 0;
}

void CBCDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CBCDlg::OnBnClickedPreviewCheck()
{
	// TODO: Add your control notification handler code here
	if (m_PreviewEdit.GetCheck() == BST_CHECKED) {
		tis->Brightness = m_BrightnessAmount;
		tis->Contrast = m_ContrastAmount;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);	
	} else {
		tis->Brightness = 0;
		tis->Contrast = 1;
		pThread = AfxBeginThread(_propertyChangedRoutine, tis, THREAD_PRIORITY_NORMAL, 0, 0);
	}
	

}

void CBCDlg::SetPropertyChangeHandler(AFX_THREADPROC handler, void * cview)
{
	_propertyChangedRoutine = (AFX_THREADPROC)handler;
	tis->pCGraffView = cview;
}
