#pragma once

class CGraffUnit
{
// Attributes
private:	
	CImage				*m_pImage;
	CImage				zBuffer;
	LPBITMAPINFOHEADER	m_lpBMIH;
	int					m_ColorTableEntries; // number of palette entries - initialized in constructor
public:
	bool	work;
	bool	stop;
	bool	UseZBuffer;
	float	status;			//float from 0 till 100 - percentage of compleetness


typedef struct MY_TEST_STRUCT {
	HWND hWnd;
	void * pVoid;
	int NumberOfIterations;
}MY_TEST_STRUCT;


public:
	CGraffUnit(CImage * pImage);
	~CGraffUnit(void);
	bool Show(CDC * pDC, float ZoomFactor, CRect position);
	bool CGraffUnit::CreateZBuffer();
	void BlurAverage(void);
	void CGraffUnit::BlurMotion(double sigma, int angle);
	void BlurGaussian(float sigma);
	void AddNoise(float sigma, bool distr, bool mono);
	void Invert(void);
	void Rotate180(void);
	void Rotate90CW(void);
	void Rotate90CCW(void);
	void FlipHorizontal(void);
	void FlipVertical(void);
	void Desaturate(void);
	void Affine(float a, float b);
	void Resize(int X, int Y, char resample);
	void Equalization(void);
	void Median(int Radius);
	void Sharpen(void);
	static UINT TotalVariation(LPVOID lParam);
	static UINT BalancedForwardBackward(LPVOID lParam);
	void AutoColor(void);
	void RedEye(void);
};
