// GraffView.cpp : implementation of the CGraffView class
//

#include "stdafx.h"
#include "Graff.h"

#include "GraffDoc.h"
#include "GraffView.h"
#include "ProgressBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "BlurDialog.h"
#include "AddNoiseDlg.h"
#include "ImageSizeDlg.h"
#include "BCDlg.h"
#include "MedianDlg.h"
#include "DiffusionDlg.h"
#include "MotionBlurDlg.h"

// CGraffView

IMPLEMENT_DYNCREATE(CGraffView, CScrollView)

BEGIN_MESSAGE_MAP(CGraffView, CScrollView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CScrollView::OnFilePrintPreview)
//	ON_COMMAND(ID_EDIT_COPY, &CGraffView::OnEditCopy)
	ON_COMMAND(ID_VIEW_ZOOM_IN, &CGraffView::OnViewZoomIn)
	ON_COMMAND(ID_VIEW_ZOOM_OUT, &CGraffView::OnViewZoomOut)
	ON_COMMAND(ID_VIEW_ZOOM_INIT, &CGraffView::OnViewZoomInit)
//	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_BLUR_AVERAGE, &CGraffView::OnBlurAverage)
	ON_COMMAND(ID_BLUR_GAUSSIANBLUR, &CGraffView::OnBlurGaussianblur)
	ON_COMMAND(ID_NOISE_ADDNOISE, &CGraffView::OnNoiseAddnoise)
	ON_COMMAND(ID_ADJUSTMENTS_INVERT, &CGraffView::OnAdjustmentsInvert)
//	ON_WM_MBUTTONDBLCLK()
	ON_COMMAND(ID_ROTATECANVAS_180, &CGraffView::OnRotatecanvas180)
	ON_COMMAND(ID_ROTATECANVAS_90, &CGraffView::OnRotatecanvas90)
	ON_COMMAND(ID_ROTATECANVAS_91, &CGraffView::OnRotatecanvas91)
	ON_COMMAND(ID_ROTATECANVAS_FLIPCANVASHORIZONTAL, &CGraffView::OnRotatecanvasFlipcanvashorizontal)
	ON_COMMAND(ID_ROTATECANVAS_FLIPCANVASVERTICAL, &CGraffView::OnRotatecanvasFlipcanvasvertical)
	ON_COMMAND(ID_EDIT_UNDO, &CGraffView::OnEditUndo)
	ON_COMMAND(ID_EDIT_REDO, &CGraffView::OnEditRedo)
	ON_COMMAND(ID_IMAGE_IMAGESIZE, &CGraffView::OnImageImagesize)
	ON_COMMAND(ID_ADJUSTMENTS_DESATURATE, &CGraffView::OnAdjustmentsDesaturate)
	//ON_WM_MBUTTONDBLCLK()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_ADJUSTMENTS_BRIGHTNESS, &CGraffView::OnAdjustmentsBrightness)
	ON_COMMAND(ID_ADJUSTMENTS_EQUALIZE, &CGraffView::OnAdjustmentsEqualize)
	ON_COMMAND(ID_NOISE_MEDIAN, &CGraffView::OnNoiseMedian)
	ON_COMMAND(ID_SHARPEN_SHARPEN, &CGraffView::OnSharpenSharpen)
	//ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_DIFFUSION_TOTALVARIATION, &CGraffView::OnDiffusionTotalvariation)
	ON_COMMAND(ID_DIFFUSION_BALANCEDFORWARD, &CGraffView::OnDiffusionBalancedforward)
	ON_COMMAND(ID_BLUR_BLUR, &CGraffView::OnBlurBlur)
	ON_COMMAND(ID_BLUR_BLURMORE, &CGraffView::OnBlurBlurmore)
	ON_COMMAND(ID_RESIZE_640, &CGraffView::OnResize640)
	ON_COMMAND(ID_RESIZE_1024, &CGraffView::OnResize1024)
	ON_COMMAND(ID_RESIZE_1600, &CGraffView::OnResize1600)
	ON_COMMAND(ID_ADJUSTMENTS_AUTOCOLOR, &CGraffView::OnAdjustmentsAutocolor)
	ON_COMMAND(ID_BLUR_MOTIONBLUR, &CGraffView::OnBlurMotionblur)
	ON_COMMAND(ID_ADJUSTMENTS_REDEYEELIMINATION, &CGraffView::OnAdjustmentsRedeyeelimination)
END_MESSAGE_MAP()

// CGraffView construction/destruction

CGraffView::CGraffView()
: m_ifFirstCall(true)
{
	// TODO: add construction code here

	m_ZoomFactor = 1;
}

CGraffView::~CGraffView()
{
}

BOOL CGraffView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CScrollView::PreCreateWindow(cs);
}

// CGraffView drawing

void CGraffView::OnDraw(CDC* pDC)
{
	CGraffDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	//WINDOWPLACEMENT place;
	//GetParentFrame()->GetWindowPlacement(&place);
	
	CRect ClientArea;
	GetParentFrame()->GetClientRect(&ClientArea);

	// TODO: add draw code for native data here
	//pDoc->m_VisualImg.Show(pDC, m_ZoomFactor, place.rcNormalPosition);
	pDoc->m_VisualImg.Show(pDC, m_ZoomFactor, ClientArea);

	
}

void CGraffView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

reEvaluate: 
	int width = (int) (m_ZoomFactor * GetDocument()->m_Img.GetWidth());
	int height = (int) (m_ZoomFactor * GetDocument()->m_Img.GetHeight());

	if (m_ifFirstCall) {
		//TODO get real sizes
		if ((width > 1000) && (m_ZoomFactor > 0.0625)) { m_ZoomFactor /= 1.5; goto reEvaluate; }
		if ((height > 700) && (m_ZoomFactor > 0.0625)) { m_ZoomFactor /= 1.5; goto reEvaluate; }
		WINDOWPLACEMENT place;
		GetParentFrame()->GetWindowPlacement(&place);
		GetParentFrame()->SetWindowPos(NULL, 
									   place.rcNormalPosition.left, 
									   place.rcNormalPosition.top,
									   (int) (m_ZoomFactor * GetDocument()->m_Img.GetWidth() + 60),
									   (int) (m_ZoomFactor * GetDocument()->m_Img.GetHeight() + 80),
									   SWP_SHOWWINDOW );
		m_ifFirstCall = FALSE;
	}

	//CSize sizeTotal;
	// TODO: calculate the total size of this view
	
	// MY: scrollbars
	SetScrollSizes(MM_TEXT,CSize(width, height));	
	
	// MY: make the window the size of the main dialog
	//GetParentFrame()->RecalcLayout();
	//ResizeParentToFit( /*FALSE*/ );

	//chanche title
	CString str;
	str = GetDocument()->GetTitle() + CreateZoomString();
    GetParent()->SetWindowText(str);

	//sizeTotal.cx = sizeTotal.cy = 100;
	//SetScrollSizes(MM_TEXT, sizeTotal);
}


// CGraffView printing

BOOL CGraffView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGraffView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGraffView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CGraffView diagnostics

#ifdef _DEBUG
void CGraffView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CGraffView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CGraffDoc* CGraffView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGraffDoc)));
	return (CGraffDoc*)m_pDocument;
}
#endif //_DEBUG

CString CGraffView::CreateZoomString(void)
{
	CString str;
	if (GetDocument()->m_ifModified) str.Format("* @ %d", (int) (100*m_ZoomFactor));
	else str.Format(" @ %d", (int) (100*m_ZoomFactor));
	str += "%";
	return str;
}

void CGraffView::OnViewZoomIn()
{
	// TODO: Add your command handler code here
	if (m_ZoomFactor >= 16) return;
	if (m_ZoomFactor >= 1) m_ZoomFactor *= 2; else m_ZoomFactor *= 1.5;
	OnInitialUpdate(); 
}

void CGraffView::OnViewZoomOut()
{
	// TODO: Add your command handler code here
	if (m_ZoomFactor <= 0.0625) return;
	if (m_ZoomFactor > 1) m_ZoomFactor /= 2; else m_ZoomFactor /= 1.5;
	OnInitialUpdate(); 
}

void CGraffView::OnViewZoomInit()
{
	// TODO: Add your command handler code here
	m_ZoomFactor = 1;
	OnInitialUpdate(); 
}

void CGraffView::OnBlurAverage()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.BlurAverage();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate(); 
}

void CGraffView::OnBlurBlur()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.BlurGaussian((float) 0.75);
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();

}

void CGraffView::OnBlurBlurmore()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.BlurGaussian((float) 1.5);
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnBlurMotionblur()
{
	// TODO: Add your command handler code here
	CMotionBlurDlg motionblurDlg;
	motionblurDlg.DoModal();
	if (motionblurDlg.m_BlurAmount != 0) {
		GetDocument()->m_VisualImg.BlurMotion(motionblurDlg.m_BlurAmount, motionblurDlg.m_Angle);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
		OnInitialUpdate();
	}
}


void CGraffView::OnBlurGaussianblur()
{
	// TODO: Add your command handler code here
	CBlurDialog blurDlg;
	blurDlg.DoModal();
	if (blurDlg.m_BlurAmount != 0) {
		GetDocument()->m_VisualImg.BlurGaussian(blurDlg.m_BlurAmount);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
		OnInitialUpdate();
	}
}


UINT CGraffView::anDlgHandler(LPVOID lParam)
{
	AN_DLG_THREADINFOSTRUCT *tis = (AN_DLG_THREADINFOSTRUCT *) lParam;
	CGraffView *pObj = (CGraffView *) tis->pCGraffView;
	pObj->GetDocument()->m_VisualImg.AddNoise(tis->NoiseAmount, tis->isUniform, tis->isMonochromatic);
	pObj->Invalidate();
	return 0;
}

void CGraffView::OnNoiseAddnoise()
{
	// TODO: Add your command handler code here
	CAddNoiseDlg addnoiseDlg;
	addnoiseDlg.SetPropertyChangeHandler(&CGraffView::anDlgHandler, this);
	GetDocument()->m_VisualImg.CreateZBuffer();
	//GetDocument()->m_VisualImg.UseZBuffer = true; TOUSE: DUMMY CODE

	addnoiseDlg.DoModal();
	if (addnoiseDlg.m_NoiseAmount != 0) {
		GetDocument()->m_VisualImg.UseZBuffer = false;
		GetDocument()->m_VisualImg.AddNoise(addnoiseDlg.m_NoiseAmount, addnoiseDlg.m_uniform, addnoiseDlg.m_monochromatic);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
	}
	GetDocument()->m_VisualImg.UseZBuffer = false;
	OnInitialUpdate();
}

void CGraffView::OnAdjustmentsInvert()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Invert();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}


void CGraffView::OnRotatecanvas180()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Rotate180();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnRotatecanvas90()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Rotate90CW();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnRotatecanvas91()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Rotate90CCW();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnRotatecanvasFlipcanvashorizontal()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.FlipHorizontal();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnRotatecanvasFlipcanvasvertical()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.FlipVertical();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnEditUndo()
{
	// TODO: Add your command handler code here
	CImage *tmp = GetDocument()->m_History.Get(TRUE);
	GetDocument()->m_Img.Destroy();
	GetDocument()->m_Img.Create(tmp->GetWidth(), tmp->GetHeight(), tmp->GetBPP());
	tmp->BitBlt(GetDocument()->m_Img.GetDC(), 0, 0, SRCCOPY);
	GetDocument()->m_Img.ReleaseDC();
	OnInitialUpdate();
}

void CGraffView::OnEditRedo()
{
	// TODO: Add your command handler code here
	CImage *tmp = GetDocument()->m_History.Get(FALSE);
	GetDocument()->m_Img.Destroy();
	GetDocument()->m_Img.Create(tmp->GetWidth(), tmp->GetHeight(), tmp->GetBPP());
	tmp->BitBlt(GetDocument()->m_Img.GetDC(), 0, 0, SRCCOPY);
	GetDocument()->m_Img.ReleaseDC();
	OnInitialUpdate();
}

void CGraffView::OnImageImagesize()
{
	// TODO: Add your command handler code here
	CImageSizeDlg imagesizeDlg;
	imagesizeDlg.m_Width = GetDocument()->m_Img.GetWidth();
	imagesizeDlg.m_Height = GetDocument()->m_Img.GetHeight();
	imagesizeDlg.DoModal();
	if ((imagesizeDlg.m_Width != GetDocument()->m_Img.GetWidth()) ||
		(imagesizeDlg.m_Height != GetDocument()->m_Img.GetHeight())) {
			GetDocument()->m_VisualImg.Resize(imagesizeDlg.m_Width, imagesizeDlg.m_Height, imagesizeDlg.m_Resample);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
		OnInitialUpdate();
	}
}

void CGraffView::OnAdjustmentsDesaturate()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Desaturate();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	// MY: make the window the size of the main dialog
	WINDOWPLACEMENT place;
	GetParentFrame()->GetWindowPlacement(&place);
	GetParentFrame()->SetWindowPos(NULL, 
								   place.rcNormalPosition.left, 
								   place.rcNormalPosition.top,
								   (int) (m_ZoomFactor * GetDocument()->m_Img.GetWidth() + 20),
								   (int) (m_ZoomFactor * GetDocument()->m_Img.GetHeight() + 40),
								   SWP_SHOWWINDOW );
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit( /*FALSE*/ );
	CScrollView::OnLButtonDblClk(nFlags, point);
}



//static CCriticalSection hihi;
UINT CGraffView::bcDlgHandler(LPVOID lParam)
{
//	hihi.Lock();
	BC_DLG_THREADINFOSTRUCT *tis = (BC_DLG_THREADINFOSTRUCT *) lParam;
	CGraffView *pObj = (CGraffView *) tis->pCGraffView;
	pObj->GetDocument()->m_VisualImg.Affine(tis->Contrast, tis->Brightness);
	pObj->Invalidate();
//	hihi.Unlock();
	return 0;
}


void CGraffView::OnAdjustmentsBrightness()
{
	// TODO: Add your command handler code here
	CBCDlg bcDlg;
	bcDlg.SetPropertyChangeHandler(&CGraffView::bcDlgHandler, this);
	GetDocument()->m_VisualImg.CreateZBuffer();
	//GetDocument()->m_VisualImg.UseZBuffer = true; TOUSE: DUMMY CODE

	if (bcDlg.DoModal() == IDOK) {
		GetDocument()->m_VisualImg.UseZBuffer = false;
		GetDocument()->m_VisualImg.Affine(bcDlg.m_ContrastAmount, bcDlg.m_BrightnessAmount);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
	}
	GetDocument()->m_VisualImg.UseZBuffer = false;
	OnInitialUpdate();
}

void CGraffView::OnAdjustmentsEqualize()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Equalization();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnNoiseMedian()
{
	// TODO: Add your command handler code here
	CMedianDlg	medianDlg;
	medianDlg.DoModal();
	if (medianDlg.m_Amount != 0) {
		GetDocument()->m_VisualImg.Median(medianDlg.m_Amount);
		GetDocument()->m_ifModified = true;
		GetDocument()->m_History.Add(&GetDocument()->m_Img);
		OnInitialUpdate();
	}
}

void CGraffView::OnSharpenSharpen()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.Sharpen();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

BOOL CGraffView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default
	return FALSE;
	return CScrollView::OnEraseBkgnd(pDC);
}


void CGraffView::OnDiffusionTotalvariation()
{
	// TODO: Add your command handler code here
	CDiffusionDlg diffusionDlg;
	diffusionDlg.m_WindowTitle.Format("Total variation diffusion");
	diffusionDlg.DoModal();

	if (diffusionDlg.m_Niter != 0) {
		UGU_STRUCT * UGUStructure = new UGU_STRUCT;
		UGUStructure->pVoid = (void *) &GetDocument()->m_VisualImg;
		UGUStructure->N = diffusionDlg.m_Niter;
		AfxBeginThread(GetDocument()->m_VisualImg.TotalVariation, UGUStructure, THREAD_PRIORITY_NORMAL, 0, 0);
		CProgressBar Bar;
		Bar.Create(" Total variation:", 50, 100, 1);
		Bar.SetBarColour(RGB(130, 130, 160));
		
		Sleep(100);
		
		while (GetDocument()->m_VisualImg.work){
			Bar.SetPos((int) GetDocument()->m_VisualImg.status);
			MSG msg;
			PeekMessage(&msg, this->m_hWnd, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE);
			int A;
			if ((msg.message == WM_KEYDOWN) && (msg.wParam == 27))
				GetDocument()->m_VisualImg.stop = true;
			Sleep(10);
		}
	
		delete UGUStructure;
		if (!GetDocument()->m_VisualImg.stop)
		{
			GetDocument()->m_ifModified = true;
			GetDocument()->m_History.Add(&GetDocument()->m_Img);
			OnInitialUpdate();
		}
	}
}

void CGraffView::OnDiffusionBalancedforward()
{
	// TODO: Add your command handler code here
	CDiffusionDlg diffusionDlg;
	diffusionDlg.m_WindowTitle.Format("Balanced Forward-Backward diffusion");
	diffusionDlg.DoModal();
	if (diffusionDlg.m_Niter != 0) {
		UGU_STRUCT * UGUStructure = new UGU_STRUCT;
		UGUStructure->pVoid = (void *) &GetDocument()->m_VisualImg;
		UGUStructure->N = diffusionDlg.m_Niter;
		AfxBeginThread(GetDocument()->m_VisualImg.BalancedForwardBackward, UGUStructure, THREAD_PRIORITY_NORMAL, 0, 0);
		CProgressBar Bar;
		Bar.Create(" Balanced Forward-Backward:", 50, 100, 1);
		Bar.SetBarColour(RGB(130, 130, 160));

		Sleep(100);

		while (GetDocument()->m_VisualImg.work){
			Bar.SetPos((int) GetDocument()->m_VisualImg.status);
			MSG msg;
			PeekMessage(&msg, this->m_hWnd, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE);
			int A;
			if ((msg.message == WM_KEYDOWN) && (msg.wParam == 27))
				GetDocument()->m_VisualImg.stop = true;
			Sleep(10);
		}
	
		delete UGUStructure;

		if (!GetDocument()->m_VisualImg.stop)
		{
			GetDocument()->m_ifModified = true;
			GetDocument()->m_History.Add(&GetDocument()->m_Img);
			OnInitialUpdate();
		}
	}
}

void CGraffView::OnResize640()
{
	// TODO: Add your command handler code here
	if (GetDocument()->m_Img.GetWidth() > GetDocument()->m_Img.GetHeight())
		GetDocument()->m_VisualImg.Resize(640, 480, 'b');
	else
		GetDocument()->m_VisualImg.Resize(480, 640, 'b');
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
	
}

void CGraffView::OnResize1024()
{
	// TODO: Add your command handler code here
	if (GetDocument()->m_Img.GetWidth() > GetDocument()->m_Img.GetHeight())
		GetDocument()->m_VisualImg.Resize(1024, 768, 'b');
	else
		GetDocument()->m_VisualImg.Resize(768, 1024, 'b');
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnResize1600()
{
	// TODO: Add your command handler code here
	if (GetDocument()->m_Img.GetWidth() > GetDocument()->m_Img.GetHeight())
		GetDocument()->m_VisualImg.Resize(1600, 1200, 'b');
	else
		GetDocument()->m_VisualImg.Resize(1200, 1600, 'b');
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}

void CGraffView::OnAdjustmentsAutocolor()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.AutoColor();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();
}


void CGraffView::OnAdjustmentsRedeyeelimination()
{
	// TODO: Add your command handler code here
	GetDocument()->m_VisualImg.RedEye();
	GetDocument()->m_ifModified = true;
	GetDocument()->m_History.Add(&GetDocument()->m_Img);
	OnInitialUpdate();

}

