// GraffView.h : interface of the CGraffView class
//


#pragma once


class CGraffView : public CScrollView
{
protected: // create from serialization only
	CGraffView();
	DECLARE_DYNCREATE(CGraffView)

// Attributes
private:
	CCriticalSection criticalSection;
public:
	CGraffDoc* GetDocument() const;
	float m_ZoomFactor;				// MY: zoom factor for image to be viewed 

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CGraffView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
//	afx_msg void OnEditCopy();
	CString CreateZoomString(void);
public:
	afx_msg void OnViewZoomIn();
	afx_msg void OnViewZoomOut();
	afx_msg void OnViewZoomInit();
	afx_msg void OnBlurAverage();
public:
//	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	
public:
	afx_msg void OnBlurGaussianblur();
public:
	afx_msg void OnNoiseAddnoise();
public:
	afx_msg void OnAdjustmentsInvert();
public:
//	afx_msg void OnMButtonDblClk(UINT nFlags, CPoint point);
public:
	afx_msg void OnRotatecanvas180();
public:
	afx_msg void OnRotatecanvas90();
public:
	afx_msg void OnRotatecanvas91();
public:
	afx_msg void OnRotatecanvasFlipcanvashorizontal();
public:
	afx_msg void OnRotatecanvasFlipcanvasvertical();
public:
	afx_msg void OnEditUndo();
public:
	afx_msg void OnEditRedo();
public:
	afx_msg void OnImageImagesize();
public:
	afx_msg void OnAdjustmentsDesaturate();
public:
//	afx_msg void OnMButtonDblClk(UINT nFlags, CPoint point);
public:
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
public:
	afx_msg void OnAdjustmentsBrightness();
public:
	afx_msg void OnAdjustmentsEqualize();
public:
	afx_msg void OnNoiseMedian();
public:
	afx_msg void OnSharpenSharpen();
protected:
//	virtual void OnActivateFrame(UINT nState, CFrameWnd* pDeactivateFrame);
//	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
public:
//	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
public:
	bool m_ifFirstCall;
public:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
public:
	afx_msg void OnDiffusionTotalvariation();
public:
	afx_msg void OnDiffusionBalancedforward();
public:
	afx_msg void OnBlurBlur();
public:
	afx_msg void OnBlurBlurmore();
public:
	afx_msg void OnResize640();
public:
	afx_msg void OnResize1024();
public:
	afx_msg void OnResize1600();
public:
	afx_msg void OnAdjustmentsAutocolor();
public:
	afx_msg void OnBlurMotionblur();
public:
	afx_msg void OnAdjustmentsRedeyeelimination();

public:
	static UINT bcDlgHandler(LPVOID lParam);
	static UINT anDlgHandler(LPVOID lParam);


//	afx_msg void OnEscape();
//	afx_msg void OnEscape();
//	afx_msg void OnEscape();
	afx_msg void OnEscape();
};

#ifndef _DEBUG  // debug version in GraffView.cpp
inline CGraffDoc* CGraffView::GetDocument() const
   { return reinterpret_cast<CGraffDoc*>(m_pDocument); }
#endif

