// ImageSizeDlg.cpp : implementation file

#include "stdafx.h"
#include "Graff.h"
#include "ImageSizeDlg.h"

// CImageSizeDlg dialog

IMPLEMENT_DYNAMIC(CImageSizeDlg, CDialog)

CImageSizeDlg::CImageSizeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImageSizeDlg::IDD, pParent),
	ratio(0)
	, Width(0)
	, Height(0)
	, buissy(0)
	, m_Resample('b')
{

}

CImageSizeDlg::~CImageSizeDlg()
{
}

void CImageSizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_WidthEdit);
	DDX_Control(pDX, IDC_EDIT2, m_HeightEdit);
	DDX_Control(pDX, IDC_CHECK1, m_ProportionsCheck);
	DDX_Control(pDX, IDC_COMBO1, m_ResampleCombo);
	DDX_Control(pDX, IDC_GROUP_BOX, m_pDimGroupBox);
}


BEGIN_MESSAGE_MAP(CImageSizeDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK1, &CImageSizeDlg::OnBnClickedCheck1)
//	ON_CBN_SELCHANGE(IDC_COMBO1, &CImageSizeDlg::OnCbnSelchangeCombo1)
	ON_BN_CLICKED(IDOK, &CImageSizeDlg::OnBnClickedOk)
	ON_EN_CHANGE(IDC_EDIT1, &CImageSizeDlg::OnEnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, &CImageSizeDlg::OnEnChangeEdit2)
//	ON_EN_UPDATE(IDC_EDIT1, &CImageSizeDlg::OnEnUpdateEdit1)
END_MESSAGE_MAP()


// CImageSizeDlg message handlers

void CImageSizeDlg::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
	if (m_ProportionsCheck.GetCheck() == BST_CHECKED) {
		buissy = 1;
		CString	str;
		str.Format("%d", m_Width);
		m_WidthEdit.SetSel(0, -1);
		m_WidthEdit.ReplaceSel(str);
		m_WidthEdit.UpdateData();

		str.Format("%d", m_Height);
		m_HeightEdit.SetSel(0, -1);
		m_HeightEdit.ReplaceSel(str);
		m_HeightEdit.UpdateData();
		buissy = 0;
	}
}

//void CImageSizeDlg::OnCbnSelchangeCombo1()
//{
//	// TODO: Add your control notification handler code here
//	//if (m_ProportionsCheck.GetCheck() == BST_CHECKED) 
//	
//}

void CImageSizeDlg::PreInitDialog()
{
	// TODO: Add your specialized code here and/or call the base class

	ratio = (double) m_Width / (double) m_Height;
	
	CDialog::PreInitDialog();
}

double CImageSizeDlg::CalculatePixelDimention()
{
	CString Eq[4] = {" bytes", "K", "M", "G"};
	double pDim = (3 * Height * Width);
	int eq = 0;
	while (pDim > 1024)
	{
		pDim /= 1024;
		eq ++;
	}
	CString pDimStr;
	if (pDim == (int) pDim)
		pDimStr.Format("%.0f%s", pDim, Eq[eq]);
	else
		pDimStr.Format("%.2f%s", pDim, Eq[eq]);

	if ((double)Height * (double) Width > 715827882) pDimStr = "--";
	if (pDimWas == "") pDimWas = pDimStr;

	CString str;
	if (pDimStr == pDimWas)
		str.Format("Pixel Dimensions: %s", pDimStr);  
	else
		str.Format("Pixel Dimensions: %s (was %s)", pDimStr, pDimWas);  

	CWnd *pWnd = GetDlgItem(IDC_GROUP_BOX);
	pWnd->SetWindowTextA(str);

	return 0;
}

BOOL CImageSizeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	CString str;

	str.Format("%d", m_Width);
	m_WidthEdit.SetSel(0, -1);
	m_WidthEdit.ReplaceSel(str);
	m_WidthEdit.UpdateData();

	str.Format("%d", m_Height);
	m_HeightEdit.SetSel(0, -1);
	m_HeightEdit.ReplaceSel(str);
	m_HeightEdit.UpdateData();

	m_ProportionsCheck.SetCheck(BST_CHECKED);

	m_ResampleCombo.SetCurSel(1);

	Width = m_Width;
	Height = m_Height;
	pDimWas = "";
	CalculatePixelDimention();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CImageSizeDlg::OnEnChangeEdit1()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here

	if (buissy == 1) return;
	buissy = 1;
	CString	data, str;
	int		len;

	
	

	len = m_WidthEdit.LineLength();
	if (len == 0) str = "0"; 
	else {
		m_WidthEdit.GetWindowTextA(data);
		//m_WidthEdit.GetLine(0, data.GetBuffer(len), len);
		str = data;
	}
	str.Trim();
	Width = atoi(str);
	str.Format("%d", Width);
	if (str != data) {
		data.ReleaseBuffer();
		m_WidthEdit.SetSel(0, -1);
		m_WidthEdit.ReplaceSel(str);
		m_WidthEdit.UpdateData();
	}
	data.ReleaseBuffer();

	if (m_ProportionsCheck.GetCheck() == BST_CHECKED) {
		Height = (int) ((double) Width / ratio);
		str.Format("%d", Height);
		len = m_HeightEdit.LineLength();
		m_HeightEdit.GetWindowTextA(data);
		//m_HeightEdit.GetLine(0, data.GetBuffer(len), len);
		if (str != data) {
			m_HeightEdit.SetSel(0, -1);
			m_HeightEdit.ReplaceSel(str);
			m_HeightEdit.UpdateData();
		}
		data.ReleaseBuffer();
	}
	buissy = 0;
	CalculatePixelDimention();
}



void CImageSizeDlg::OnEnChangeEdit2()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	if (buissy == 1) return;
	buissy = 1;
	CString	data, str;
	int		len;

	len = m_HeightEdit.LineLength();
	if (len == 0) str = "0"; 
	else {
		m_HeightEdit.GetWindowTextA(data);
		//m_HeightEdit.GetLine(0, data.GetBuffer(len), len);
		str = data;
	}
	str.Trim();
	Height = atoi(str);
	str.Format("%d", Height);
	if (str != data) {
		data.ReleaseBuffer();
		m_HeightEdit.SetSel(0, -1);
		m_HeightEdit.ReplaceSel(str);
		m_HeightEdit.UpdateData();
	}
	data.ReleaseBuffer();

	if (m_ProportionsCheck.GetCheck() == BST_CHECKED) {
		Width = (int) ((double) Height * ratio);
		str.Format("%d", Width);
		len = m_WidthEdit.LineLength();
		m_WidthEdit.GetWindowTextA(data);
		//m_WidthEdit.GetLine(0, data.GetBuffer(len), len);	
		if (str != data) {
			m_WidthEdit.SetSel(0, -1);
			m_WidthEdit.ReplaceSel(str);
			m_WidthEdit.UpdateData();
		}
		data.ReleaseBuffer();
	}
	buissy = 0;
	CalculatePixelDimention();
}

void CImageSizeDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	if (Width <= 0) {AfxMessageBox("Incompatible width value"); return;}
	if (Height <= 0) {AfxMessageBox("Incompatible height value"); return;}
	m_Width = Width;
	m_Height = Height;
	switch (m_ResampleCombo.GetCurSel()) {
		case 0: m_Resample = 'n'; break;
		case 1: m_Resample = 'b'; break;
	}

	OnOK();
}


//void CImageSizeDlg::OnEnUpdateEdit1()
//{
//	// TODO:  If this is a RICHEDIT control, the control will not
//	// send this notification unless you override the CDialog::OnInitDialog()
//	// function to send the EM_SETEVENTMASK message to the control
//	// with the ENM_UPDATE flag ORed into the lParam mask.
//
//	// TODO:  Add your control notification handler code here
//}
